/*
 * Copyright (C) 2007 BEYLER Jean Christophe
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA
 */

#ifndef H_BJC_HANDLE_IMAGE_200706181538
#define H_BJC_HANDLE_IMAGE_200706181538

#include "Image.h"
#include "ListImage.h"

/* macros =================================================================== */
/* constants ================================================================ */
/* types ==================================================================== */
typedef struct sHandleImage_ SHandleImage;

/* structures =============================================================== */
/* Structure de base pour gerer les differentes images */
struct sHandleImage_
{
  /* La liste des images */
  SListImage *list;
  /* La zone ou vont evoluer les images */
  SDL_Rect area;
  /* Le nom du fichier de l'image */
  char *fname;
};

/* internal public functions ================================================ */
/* entry points ============================================================= */
SHandleImage *Handle_Init (const char *fname, SDL_Rect *area);
void Handle_Destroy (SHandleImage *);
int Handle_AddImage (SHandleImage *);
int Handle_RemoveImage (SHandleImage *);
void Handle_Frame (SHandleImage*, SDL_Surface*);

/* public variables ========================================================= */
/* inline public functions  ================================================= */

#endif /* not H_BJC_HANDLE_IMAGE_200706181538 */
