/*
* Copyright (C) 2007 Javier Loureiro
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef H_GTK_SDL_NJ_0405071201
#define H_GTK_SDL_NJ_0405071201

#include <stdlib.h>

#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gtk/gtkwidget.h>

#ifdef G_OS_WIN32
#  include <gdk/gdkwin32.h>
#else
#  include <gdk/gdkx.h>
#endif

#include <SDL.h>

G_BEGIN_DECLS

/* macros =================================================================== */
#define GTK_TYPE_SDL            (gtk_sdl_get_type ())
#define GTK_SDL(obj)            (GTK_CHECK_CAST ((obj), GTK_TYPE_SDL, GtkSDL))
#define GTK_SDL_CLASS(klass)    (GTK_CHECK_CLASS_CAST ((klass), GTK_TYPE_SDL, GtkSDLClass))
#define GTK_IS_SDL(obj)         (GTK_CHECK_TYPE ((obj), GTK_TYPE_SDL))
#define GTK_IS_SDL_CLASS(klass) (GTK_CHECK_CLASS_TYPE ((klass), GTK_TYPE_SDL))

/* constants ================================================================ */
/* types ==================================================================== */
typedef struct _GtkSDL GtkSDL;
typedef struct _GtkSDLClass GtkSDLClass;

/* structures =============================================================== */
struct _GtkSDL
{
  GtkWidget widget;

  /*< public >*/
  SDL_Surface *surface;
  gint width;
  gint height;
  gint bpp;
  Uint16 flags;
};

struct _GtkSDLClass
{
  GtkWidgetClass parent_class;
};

/* internal public functions ================================================ */
GtkType gtk_sdl_get_type (void);

/* entry points ============================================================= */
GtkWidget *gtk_sdl_new (gint width, gint height, gint bpp, Uint32 flags);
void gtk_sdl_size (GtkSDL *sdl, gint width, gint height);
void gtk_sdl_display_update (GtkSDL *sdl);
void gtk_sdl_configure(GtkSDL * sdl , int option);

/* public variables ========================================================= */
/* inline public functions  ================================================= */

G_END_DECLS

#endif /* H_GTK_SDL_NJ_0405071201 */
